"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _RpkiClientConnector2 = _interopRequireDefault(require("./RpkiClientConnector"));
var _brembo = _interopRequireDefault(require("brembo"));
var _ExternalConnector = _interopRequireDefault(require("./ExternalConnector"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, _toPropertyKey(descriptor.key), descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }
function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }
function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
var api = "https://api.packetvis.com/v1/rpki/";
var PacketVisConnector = exports["default"] = /*#__PURE__*/function (_RpkiClientConnector) {
  _inherits(PacketVisConnector, _RpkiClientConnector);
  var _super = _createSuper(PacketVisConnector);
  function PacketVisConnector(options) {
    var _options$host, _options$host2;
    var _this;
    _classCallCheck(this, PacketVisConnector);
    _this = _super.call(this, _objectSpread(_objectSpread({}, options), {}, {
      verbose: true,
      host: _brembo["default"].build((_options$host = options.host) !== null && _options$host !== void 0 ? _options$host : api, {
        path: ["static"]
      })
    }));
    _defineProperty(_assertThisInitialized(_this), "getVRPs", function () {
      try {
        var fs = require('fs'); // Load only for node
        var file = ".cache/vrps.json";
        if (fs.existsSync(file)) {
          var stats = fs.statSync(file);
          if (new Date() - stats.mtime < 30 * 60 * 1000) {
            // Newer than 30 min

            var payload = JSON.parse(fs.readFileSync(file, 'utf8'));
            _this.cacheConnector.setVRPs(payload.roas);
            _this._applyRpkiClientMetadata(payload === null || payload === void 0 ? void 0 : payload.metadata);
            _this.metadata.lastModified = stats.mtime.toISOString();
            return _this.cacheConnector.getVRPs();
          } else {
            throw new Error("RPKI cache too old .cache/vrps.json");
          }
        } else {
          throw new Error("RPKI cache missing .cache/vrps.json");
        }
      } catch (error) {
        return Promise.reject(error);
      }
    });
    _defineProperty(_assertThisInitialized(_this), "getExpiringElements", function (vrp, expires, now) {
      if (_this.metaIndex) {
        return Promise.resolve(_this.metaIndex.getExpiring(vrp, expires, now));
      } else {
        var url = _brembo["default"].build(_this.vrpHost, {
          path: ["meta", "expiring"],
          params: {
            prefix: vrp.prefix,
            asn: vrp.asn,
            maxlength: vrp.maxLength,
            expires: expires,
            client: _this.clientId
          }
        });
        return _this.axios({
          method: "get",
          url: url
        }).then(function (_ref) {
          var data = _ref.data;
          return data.data;
        });
      }
    });
    _this.minimumRefreshRateMinutes = 1;
    _this.vrpHost = (_options$host2 = options.host) !== null && _options$host2 !== void 0 ? _options$host2 : api;
    _this.cacheConnector = new _ExternalConnector["default"]({});
    return _this;
  }
  return _createClass(PacketVisConnector);
}(_RpkiClientConnector2["default"]);